/* idasearch.h Copyright 2001 Robert Hilchie */

#include "board.h"

#define MAXDEPTH 100

// Objects of this class perform the iterative deepening A* search to
// solve the fifteen puzzle
class IDAsearch
{
  public:
    // Perform the iterative deepening A* search
    void search(Pattern &p4, Pattern &p3, Board &b);

  private:
    // Do a recursive heuristically guided depth-first search
    bool dfs(unsigned level, unsigned forbid, Index i1, Index i2, Index i3, Index i4);

    // Move tables from the two patterns
    Movetable *movetable4, *movetable3;

    // Pattern databases
    unsigned char *dbase4, *dbase3;

    // Counts the number of nodes created in the depth-first search
    unsigned nodecount;

    // List of moves in reverse order
    unsigned char solution[MAXDEPTH];
};